 ;FILE SELECT FOR HARDDISK
;AND COPY FROM ONE
;HARD DISK TO OTHER

	ORG	64000
CATBUF	EQU	#6800
SELSTO	EQU	#6400
LDBUF	EQU	#61A0
MESS	EQU	#C0A
LDMASC	EQU	#87C
REABE	EQU	#51F
REAP	EQU	#987 ;sets cyl offset (DE reg)
DI2BCO	EQU	#3CA8
WRIBE	EQU	#57E
SACAT	EQU	#7AF
SACAT2	EQU	#849
SADB1	EQU	#7A6
WRIP	EQU	#97E

;line, messages

INIT	LD	A,2
	CALL	#1601
	LD	BC,#1101
	CALL	ATC
	LD	DE,M1
	XOR	A
	CALL	MESS
	LD	BC,#1110
	CALL	ATC
	LD	DE,M2
	XOR	A
	CALL	MESS
	LD	HL,#2030
	LD	(M3+1),HL
	LD	BC,#1300
	CALL	ATC
	LD	DE,M3
	XOR	A
	CALL	MESS
	LD	A,8
	LD	(23658),A
;clear counters
	XOR	A
	LD	HL,SELCN
	LD	B,3
CLECNS	LD	(HL),A
	INC	HL
	DJNZ	CLECNS

	LD	HL,256*45
	LD	(23677),HL
	LD	BC,#FF
	LD	DE,#101
	CALL	#24BA
	EXX
	LD	HL,#2758
	EXX

	LD	HL,SELSTO
	LD	BC,1024
CLSELL	LD	(HL),0
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,CLSELL
	RET

;load CAT
LOADCH	LD	IX,LDBUF
	LD	A,"S" ;for test
	LD	(IX+1),A
	LD	(SPSTOR),SP
	CALL	SHD ;set HD ROM
	CALL	LDMASC
	LD	E,(IX-31)
	LD	D,(IX-30) ;cyl offset
	LD	A,(IX-29) ;first data sector
	DEC	A
	LD	HL,CATBUF
	LD	BC,1
	PUSH	BC
	PUSH	HL
	CALL	REABE
	POP	HL
	PUSH	HL
	LD	A,(IX-29)
	LD	B,0
	DEC	A
	LD	(PAGES),A ;max pages
	RLCA
	RLCA
	SLA	A
	RL	B
	SLA	A
	RL	B ;mult by 16
	LD	C,A
	PUSH	BC
	LD	DE,32
	INC	HL
;count files in charea
FODL	LD	A,(HL)
	OR	A
	JR	Z,NOMF
	ADD	HL,DE
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,FODL
NOMF	POP	HL
	OR	A
	SBC	HL,BC
	LD	C,L
	LD	B,H
	PUSH	BC
	LD	BC,#110D
	CALL	ATC
	POP	BC
	CALL	BCOUTP
	POP	HL
	POP	BC

;outprint file datas
CATBL	PUSH	HL
	PUSH	BC
	LD	BC,0
	CALL	ATC
	LD	E,16
CATPL	INC	HL
	LD	A,(HL)
	OR	A ;is file or empty
	JR	NZ,PRIFD
	LD	B,32
FILSL	LD	A,32
	RST	16
	DJNZ	FILSL
	LD	BC,31
	ADD	HL,BC
	JP	PRNEXL
PRIFD	LD	BC,14
	ADD	HL,BC
	LD	D,1
ZTL	LD	A,(HL)
	CP	32
	JR	NZ,NOTSP
	INC	D
	DEC	HL
	DEC	C
	JR	NZ,ZTL
NOTSP	OR	A
	SBC	HL,BC
	LD	B,15
SPET	LD	A,B
	CP	D
	JR	NC,NAML
	LD	A,"-"
	JR	CRST
NAML	LD	A,(HL)
CRST	RST	16
	INC	HL
	DJNZ	SPET
	LD	A,32
	RST	16
	LD	BC,16
	OR	A
	SBC	HL,BC
	LD	A,(HL)
	LD	D,A ;Save type
	OR	A
	JR	Z,PRG
	CP	3
	JR	Z,CODE
	LD	A,"H"
	RST	16
	LD	A,":"
	RST	16
	LD	A,"?"
	RST	16
	INC	HL
	INC	HL
	INC	HL
	JR	SPBLEN
PRG	LD	A,"P"
	JR	PRTSP
CODE	LD	A,"B"
PRTSP	RST	16
	LD	A,":"
	RST	16
	ADD	HL,BC
	INC	HL
	INC	HL
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	LD	A,D
	OR	A
	JR	NZ,NOTPRG
	LD	A,B
	CP	#80
	JR	NZ,NOTPRG
	LD	A,"-"
	RST	16
	JR	SPBLEN
NOTPRG	CALL	BCOUTP
SPBLEN	LD	A,32
	RST	16
	LD	A,"L"
	RST	16
	LD	A,":"
	RST	16
	DEC	HL
	DEC	HL
	LD	B,(HL)
	DEC	HL
	LD	C,(HL)
	CALL	BCOUTP
	LD	BC,15
	ADD	HL,BC
	LD	A,(HL)
	OR	A
	JR	Z,SKNS
	LD	A,(23688)
	DEC	A
	DEC	A
	JR	NZ,SPFI
	LD	A,8
	RST	16
	JR	SKSP
SPFI	DEC	A
	JR	Z,SKSP
	LD	B,A
SPF	LD	A,32
	RST	16
	DJNZ	SPF
SKSP	LD	A,20
	RST	16
	LD	A,1
	RST	16
	LD	C,(HL)
	LD	B,0
	CALL	BCOUTP
	LD	A,20
	RST	16
	XOR	A
	RST	16
SKNS	LD	A,(23688)
	DEC	A
	JR	Z,SKRF
	LD	B,A
TOLIE	LD	A,32
	RST	16
	DJNZ	TOLIE
SKRF	INC	HL
PRNEXL	DEC	E
	JP	NZ,CATPL
	XOR	A
	LD	(CUPOS),A
	LD	D,48
	CALL	ATRC
	LD	BC,#1106
	CALL	ATC
	POP	BC
	PUSH	BC
	LD	B,0
	CALL	BCOUTP
	LD	A," "
	RST	16 ;clear second digit
;when count back
	POP	BC

;Action by pressed key
KEY	LD	A,(23611)
	BIT	5,A
	JR	Z,KEY
	LD	A,(23560)
	CP	13
	JR	Z,MARK
	CP	"6"
	CALL	Z,CUD
	CP	"7"
	CALL	Z,CUUP
	CP	"A"
	JR	Z,CATEND
	CP	"8"
	JR	Z,NEP
	CP	"S"
	JP	Z,SAVETF
	CP	"Q"
	JP	Z,ENDSG ;exit wuthout save
;CP "D" ;for deselect
;JP Z,DESELC
	CP	"5"
	JR	NZ,KEY
	LD	DE,-512
	DEC	C
	JR	ADORS
NEP	LD	DE,512
	INC	C
ADORS	LD	A,C
	OR	A
	JR	NZ,ISMAXP
	INC	C
	JR	KEY
ISMAXP	LD	B,A
	LD	A,(PAGES)
	INC	A
	CP	B
	JR	NZ,ADV
	DEC	C
	JR	KEY
ADV	POP	HL
	ADD	HL,DE
	RES	5,(IY+1)
	JP	CATBL
CATEND
	LD	SP,(SPSTOR)
	LD	B,0
	LD	A,(SELCN)
	LD	C,A
	RET

MARK	PUSH	BC
	LD	A,(SELCN)
	CP	32
	JR	NZ,MARK2
	CALL	#EFB ;error sound
	LD	BC,#150A
	CALL	ATC
	XOR	A
	LD	DE,MAXMES
	CALL	MESS
	LD	HL,FLII+1
	LD	A,1
	XOR	(HL)
	LD	(HL),A
	JP	SKIPD
MARK2	LD	A,(CUPOS)
	DEC	C ;page #
	RLCA
	RLCA
	RLCA
	RLCA
	RLA
	LD	E,A
	LD	A,C
	RLA
	LD	D,A
	LD	HL,CATBUF
	ADD	HL,DE
	LD	DE,31
	ADD	HL,DE
	LD	A,(HL)
	OR	A ;is selected allready
	JR	NZ,SKIPD
	LD	DE,-31
	ADD	HL,DE
	LD	A,22
	RST	16
	LD	A,(CUPOS)
	RST	16
	LD	A,30
	RST	16
;set inverse
	LD	A,20
	RST	16
	LD	A,1
	RST	16
	LD	A,(SELCN)
	INC	A
	PUSH	AF
	LD	C,A
	LD	B,0
	CALL	BCOUTP
	LD	A,20
;back to noninverse
	RST	16
	XOR	A
	RST	16
	LD	BC,#1300
	CALL	ATC
	POP	AF
	PUSH	AF
	LD	C,A
	LD	B,0
	CALL	BCOUTP
	POP	AF
	PUSH	AF
	LD	(SELCN),A
;max 31 file selectable in one pass
	DEC	A
	LD	D,0
	RLCA
	RLCA
	RLCA
	SLA	A
	RL	D
	SLA	A
	RL	D
	LD	E,A
	PUSH	HL
	LD	HL,SELSTO
	ADD	HL,DE
	EX	DE,HL
	POP	HL
	LD	BC,31
	LDIR
	POP	AF
;put select number
	LD	(HL),A
;calc total len to copy
	LD	DE,-7
	ADD	HL,DE
	LD	E,(HL)
	LD	D,0
	LD	HL,(TOTLEN)
	ADD	HL,DE
	LD	(TOTLEN),HL
	LD	BC,#1313
	CALL	ATC
	CALL	DI2BCO ;ROM rutine
	XOR	A
	LD	DE,SEPKB
	CALL	MESS

SKIPD	POP	BC
	RES	5,(IY+1)
	JP	KEY

;Subroutines

BCOUTP	PUSH	HL
	PUSH	DE
	CALL	#2D2B
	CALL	#2DE3
	POP	DE
	POP	HL
	RET

ATC	LD	A,22
	RST	16
	LD	A,B
	RST	16
	LD	A,C
	RST	16
	RET

CUD	LD	A,(CUPOS)
	CP	15
	RET	Z
	INC	A
	JR	COMCU

CUUP	LD	A,(CUPOS)
	OR	A
	RET	Z
	DEC	A
COMCU	PUSH	BC
	EX	AF,AF'
	LD	A,(CUPOS)
	LD	D,56
	CALL	ATRC
	EX	AF,AF'
	LD	(CUPOS),A
	LD	D,48
	CALL	ATRC
	RES	5,(IY+1)
	POP	BC
	RET

ATRC	RLCA
	RLCA
	RLCA
	RLCA
	LD	B,0
	RLA
	RL	B
	LD	C,A
	LD	HL,#5800
	ADD	HL,BC
	LD	B,32
YELL	LD	(HL),D
	INC	HL
	DJNZ	YELL
M1	RET

;Messages

	DEFM	"Page:"
M2	DEFB	160
	DEFM	" files on part"
M3	DEFB	"."+128
	DEFM	"0  files selected"
SEPKB	DEFB	" "+128
	DEFM	" KB "
MAXMES	DEFB	" "+128
FLII	DEFB	20,1
	DEFM	"Max 32 file."
	DEFB	20,0,32+128

;Store values
CUPOS	DEFB	0
SELCN	DEFB	0
TOTLEN	DEFS	2 ;must after selcn
PAGES	DEFS	1
SPSTOR	DEFS	2
SLEN	DEFS	1
SPOF	DEFS	2
H1OF	DEFS	2

SHD	LD	A,1
	JR	SCM
SH2	LD	A,0
SCM	OUT	(#A9),A
	RET

SAVETF	CALL	#D6B ;CLS
	LD	A,2
	CALL	#1601
	LD	A,(SELCN)
	OR	A
	JP	Z,ENDSG ;exit if 0 selected
	LD	HL,SELSTO

MAINSL	PUSH	AF
	PUSH	HL
	INC	HL
	LD	A,(HL) ;get first char
	LD	IX,LDBUF
	LD	(IX+1),A
	CALL	SHD
	CALL	LDMASC
	POP	HL
	PUSH	HL
	LD	BC,22
	ADD	HL,BC
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	XOR	A
	LD	(SLEN),A ;init to no second pass
	LD	A,(HL)
	CP	74
	JR	C,ONEPS
	SUB	73
	LD	(SLEN),A ;sector count for second pass
	LD	A,73
ONEPS	PUSH	AF
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	(SPOF),DE
	LD	A,D
	OR	A

NOTP	LD	HL,CATBUF
	POP	AF
	CALL	REAP
	LD	L,(IX-31)
	LD	H,(IX-30) ;store track offset
	LD	(H1OF),HL

COPYFD	POP	HL
	LD	DE,LDBUF
	LD	BC,32
	LDIR
	PUSH	HL ;save pos of next file data

	CALL	SH2

;OUTPRINT NAME

	LD	DE,LDBUF+1
	LD	B,15
OUNL	LD	A,(DE)
	RST	16
	INC	DE
	DJNZ	OUNL
	LD	A,13
	RST	16
;ensure scroll
	LD	A,13
	LD	(23692),A ;SCROLL CNT

;Save to HD 2
	LD	IX,LDBUF
	CALL	SACAT
	LD	HL,(SPOF)
	LD	A,H
	AND	A
	JR	Z,TOSAC2
	EX	DE,HL
	LD	(HL),E
	INC	HL
	LD	(HL),D ;put stack values in header
TOSAC2	CALL	SACAT2
	LD	HL,CATBUF
	LD	A,(SLEN)
	OR	A
	JR	Z,ONESP
	LD	A,73
	CALL	SADB1
	POP	HL
	PUSH	HL
;get start sector
	LD	DE,-10
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	HL,73
	ADD	HL,DE
	LD	B,H
	LD	C,L ;this is ss of second pass
	CALL	SHD
	LD	HL,CATBUF
	LD	A,(SLEN)
	LD	DE,(H1OF)
	CALL	REABE
	CALL	SH2


GET2PS	LD	H,(IX-2)
	LD	L,(IX-3)
	LD	DE,73
	ADD	HL,DE
	LD	B,H
	LD	C,L
	LD	HL,CATBUF
	LD	A,(SLEN)
	CALL	WRIP
	JR	POPS

ONESP	CALL	SADB1-3

POPS	POP	HL
	POP	AF
	DEC	A
	JP	NZ,MAINSL ;can't with DJNZ

ENDSG	LD	BC,100 ;sign for end
	LD	SP,(SPSTOR)
	RET
ZZ
